diff mbox series

[4/7] setlocalversion: use only the correct release tag for git-describe

Message ID 20230122141428.115372-4-masahiroy@kernel.org (mailing list archive)
State New, archived
Headers show
Series [1/7] kbuild: do not put .scmversion into the source tarball | expand

Commit Message

Masahiro Yamada Jan. 22, 2023, 2:14 p.m. UTC
Currently, setlocalversion uses any annotated tag for git-describe.
If we are at a tagged commit, it will not append the commit hash.

  $ git checkout v6.2-rc1^
  $ make -s defconfig prepare
  $ make kernelrelease
  6.1.0-14595-g292a089d78d3
  $ git tag -a foo -m foo
  $ make kernelrelease
  6.1.0

If a local tag 'foo' exists, it pretends to be a released version
'6.1.0', while there are many commits on top of it.

The output should be consistent irrespective of such a local tag.
Pass the correct release tag to --match option of git-describe.

In the mainline kernel, the SUBLEVEL is always '0' but it is omitted
from the tag.

  version         tag
  6.1.0      ->   v6.1        (mainline)
  6.2.0-rc5  ->   v6.2-rc5    (mainline, release candidate)
  6.1.7      ->   v6.1.7      (stable)

Signed-off-by: Masahiro Yamada <masahiroy@kernel.org>
---

 scripts/setlocalversion | 23 +++++++++++++++++------
 1 file changed, 17 insertions(+), 6 deletions(-)

Comments

Masahiro Yamada Feb. 5, 2023, 12:02 p.m. UTC | #1
On Sun, Jan 22, 2023 at 11:14 PM Masahiro Yamada <masahiroy@kernel.org> wrote:
>
> Currently, setlocalversion uses any annotated tag for git-describe.
> If we are at a tagged commit, it will not append the commit hash.
>
>   $ git checkout v6.2-rc1^
>   $ make -s defconfig prepare
>   $ make kernelrelease
>   6.1.0-14595-g292a089d78d3
>   $ git tag -a foo -m foo
>   $ make kernelrelease
>   6.1.0
>
> If a local tag 'foo' exists, it pretends to be a released version
> '6.1.0', while there are many commits on top of it.
>
> The output should be consistent irrespective of such a local tag.
> Pass the correct release tag to --match option of git-describe.
>
> In the mainline kernel, the SUBLEVEL is always '0' but it is omitted
> from the tag.
>
>   version         tag
>   6.1.0      ->   v6.1        (mainline)
>   6.2.0-rc5  ->   v6.2-rc5    (mainline, release candidate)
>   6.1.7      ->   v6.1.7      (stable)
>
> Signed-off-by: Masahiro Yamada <masahiroy@kernel.org>


I will drop this patch,
and send an alternative one.
diff mbox series

Patch

diff --git a/scripts/setlocalversion b/scripts/setlocalversion
index b8e1018d611e..a4c9a61b0665 100755
--- a/scripts/setlocalversion
+++ b/scripts/setlocalversion
@@ -27,6 +27,7 @@  fi
 scm_version()
 {
 	local short
+	local tag
 	short=false
 
 	cd "$srctree"
@@ -42,9 +43,14 @@  scm_version()
 		return
 	fi
 
-	# If we are at a tagged commit (like "v2.6.30-rc6"), we ignore it
-	# because this version is defined in the top level Makefile.
-	if [ -z "$(git describe --exact-match 2>/dev/null)" ]; then
+	# convert the version to a tag
+	#   mainline kernel:  6.2.0-rc5  ->  v6.2-rc5
+	#   stable kernel:    6.1.7      ->  v6.1.7
+	tag=v$(echo "${KERNELVERSION}" | sed 's/^\(.*\..*\)\.0\(.*\)$/\1\2/')
+
+	# If we are at a tagged commit and the tag matches the version defined
+	# in the top level Makefile, we ignore it.
+	if [ -z "$(git describe --exact-match --match=$tag 2>/dev/null)" ]; then
 
 		# If only the short version is requested, don't bother
 		# running further git commands
@@ -52,9 +58,9 @@  scm_version()
 			echo "+"
 			return
 		fi
-		# If we are past a tagged commit (like
-		# "v2.6.30-rc5-302-g72357d5"), we pretty print it.
-		if atag="$(git describe 2>/dev/null)"; then
+		# If we are past the release tag, we pretty print it.
+		# (like 6.1.0-14595-g292a089d78d3)
+		if atag="$(git describe --match=$tag 2>/dev/null)"; then
 			echo "$atag" | awk -F- '{printf("-%05d", $(NF-1))}'
 		fi
 
@@ -102,6 +108,11 @@  if ! test -e include/config/auto.conf; then
 	exit 1
 fi
 
+if [ -z "${KERNELVERSION}" ]; then
+	echo "KERNELVERSION is not set" >&2
+	exit 1
+fi
+
 # localversion* files in the build and source directory
 res="$(collect_files localversion*)"
 if test ! "$srctree" -ef .; then